//void PlotEcompo(const Char_t *fname = "results/jsf.pfoanl.uds91.v0.std.10k.root")
//void PlotEcompo(const Char_t *fname = "results/jsf.pfoanl.uds200.v0.std.10k.root")
//void PlotEcompo(const Char_t *fname = "results/jsf.pfoanl.uds350.v0.std.10k.root")
//void PlotEcompo(const Char_t *fname = "results/jsf.pfoanl.uds500.v0.std.10k.root")
//
//void PlotEcompo(const Char_t *fname = "results/jsf.pfoanl.zh350.v0.std.10k.root")
//
//void PlotEcompo(const Char_t *fname = "results/jsf.pfoanl.zz200.v0.std.10k.root")
//void PlotEcompo(const Char_t *fname = "results/jsf.pfoanl.zz300.v0.std.10k.root")
//void PlotEcompo(const Char_t *fname = "results/jsf.pfoanl.zz400.v0.std.10k.root")
//void PlotEcompo(const Char_t *fname = "results/jsf.pfoanl.zz500.v0.std.10k.root")
void PlotEcompo(const Char_t *fname = "results/jsf.pfoanl.zz700.v0.std.10k.root")
{
  // ------------------------------------------------------------
  //  Open shared libraries
  // ------------------------------------------------------------
  gSystem->Load("libJSF.so");
  gSystem->Load("libS4Utils.so");
  gSystem->Load("libAnlib.so");

  // ------------------------------------------------------------
  //  Open event file and apply cuts
  // ------------------------------------------------------------
  TFile *filep = TFile::Open(fname);
  TNtupleD *tupep = (TNtupleD *)gROOT->FindObject("hevt");

  //tupep->Draw(">>elist","npj1>=5&&npj2>=5&&abs(cosj1)<0.8&&abs(cosj2)<0.8&&mass>70&&mass<110","goff");
#if 0
  tupep->Draw(">>elist","npj1>=5&&npj2>=5&&abs(cosj1)<0.8&&abs(cosj2)<0.8","goff");
#else
  tupep->Draw(">>elist","npj1>=5&&npj2>=5&&abs(cosj1)<0.95&&abs(cosj2)<0.95","goff");
#endif
  TEventList *elistp = (TEventList *)gROOT->FindObject("elist");

  const Double_t kNsig = 2.;	// fit range for gaussian fit in units of sigma

  // ------------------------------------------------------------
  //  Define histograms
  // ------------------------------------------------------------
#if 0
  Double_t dEmin = -15.;
  Double_t dEmax = +15.;
  Double_t dEvmn = -20.;
  Double_t dEvmx = +20.;
  Double_t Emin  =   0.;
  Double_t Emax  = 100.;
  //Double_t Emax  = 180.;
#else
  Double_t dEmin = -30.;
  Double_t dEmax = +30.;
  Double_t dEvmn = -40.;
  Double_t dEvmx = +40.;
  Double_t Emin  =   0.;
  //Double_t Emax  = 500.;
  Double_t Emax  = 350.;
#endif
  TH1D *hDetkpbp  = new TH1D("hDetkpbp","",120,dEmin,dEmax);
  TH1D *hDeempbp  = new TH1D("hDeempbp","",120,dEmin,dEmax);
  TH1D *hDehdpbp  = new TH1D("hDehdpbp","",120,dEmin,dEmax);
  TH1D *hDevis    = new TH1D("hDevis"  ,"",100,dEvmn,dEvmx);
  TH1D *hDecm     = new TH1D("hDecm"   ,"",100,dEvmn,dEvmx);
  TH1D *hEtkpbp   = new TH1D("hEtkpbp" ,"",100, Emin, Emax);
  TH1D *hEempbp   = new TH1D("hEempbp" ,"",100, Emin, Emax);
  TH1D *hEhdpbp   = new TH1D("hEhdpbp" ,"",100, Emin, Emax);
  TH1D *hEahpbp   = new TH1D("hEahpbp" ,"",100, Emin, Emax);
  //TH1D *hEahpbp   = new TH1D("hEahpbp" ,"",100, 0., 100.);
  TH1D *hEtotpbp  = new TH1D("hEtotpbp","",100, Emin, 2*Emax);
  TH1D *hEallpbp  = new TH1D("hEallpbp","",100, Emin, 2*Emax);

  // ------------------------------------------------------------
  //  Loop over selected events and fill up histograms
  // ------------------------------------------------------------
  Int_t nevt = elistp->GetN();
  cerr << "Nevt = " << nevt << endl;
#if 1
  Long64_t   *evlist = elistp->GetList();
  ofstream fevlist("fevlist");
  fevlist << nevt << endl;
  for (Int_t i=0; i<nevt; i++) {
     fevlist << evlist[i] << endl;
  }
#endif

  for (Int_t i=0; i<nevt; i++) {
    Int_t ievt = elistp->GetEntry(i);	// get event number

    Double_t npj1, npj2, cosj1, cosj2, mass;
    Double_t etk, eem, ehd, etkpbp, eempbp, ehdpbp, eah, eahznu;

    tupep->SetBranchAddress("npj1",&npj1);
    tupep->SetBranchAddress("npj2",&npj2);
    tupep->SetBranchAddress("cosj1",&cosj1);
    tupep->SetBranchAddress("cosj2",&cosj2);
    tupep->SetBranchAddress("mass",&mass);
    tupep->SetBranchAddress("etk",&etk);
    tupep->SetBranchAddress("eem",&eem);
    tupep->SetBranchAddress("ehd",&ehd);
    tupep->SetBranchAddress("etkpbp",&etkpbp);
    tupep->SetBranchAddress("eempbp",&eempbp);
    tupep->SetBranchAddress("ehdpbp",&ehdpbp);
    tupep->SetBranchAddress("eah",&eah);
    if (tupep->FindBranch("eahznu")) tupep->SetBranchAddress("eahznu",&eahznu);
    else                         eahznu = 0.;

    tupep->GetEntry(ievt);	// get this event

    hDetkpbp->Fill(etk-etkpbp,1.);
    hDeempbp->Fill(eem-eempbp,1.);
    hDehdpbp->Fill(ehd-ehdpbp,1.);
    hDevis  ->Fill(etk+eem+ehd-etkpbp-eempbp-ehdpbp,1.);
    hDecm   ->Fill(etk+eem+ehd-etkpbp-eempbp-ehdpbp-eah+eahznu,1.);
    hEtkpbp ->Fill(etkpbp,1.);
    hEempbp ->Fill(eempbp,1.);
    hEhdpbp ->Fill(ehdpbp,1.);
    hEahpbp ->Fill(eah-eahznu,1.);
    hEtotpbp->Fill(etkpbp+eempbp+ehdpbp,1.);
    hEallpbp->Fill(etkpbp+eempbp+ehdpbp+eah-eahznu,1.);
  }
  // ------------------------------------------------------------
  //  Draw histograms
  // ------------------------------------------------------------
  gStyle->SetOptFit(1);
  gStyle->SetOptStat(111111);

  TCanvas *c1p = new TCanvas("c1","",20,20,1220,820);
  TCanvas &c1  = *c1p;
  c1.Divide(3,2);
  Int_t id = 0;

  TPad *cpadp;
#if 0
  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hDetkpbp->Draw();
  ANLGaussFitter gfit(hDetkpbp,kNsig);
  gfit.GetFunction()->Draw("same");
  hDetkpbp->SetFillColor(42);
  hDetkpbp->SetFillStyle(1000);
  hDetkpbp->GetXaxis()->SetTitle("#Delta E_{tk} [GeV]");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hDeempbp->Draw();
  ANLGaussFitter gfit(hDeempbp,kNsig);
  gfit.GetFunction()->Draw("same");
  hDeempbp->SetFillColor(50);
  hDeempbp->SetFillStyle(3001);
  hDeempbp->GetXaxis()->SetTitle("#Delta E_{em} [GeV]");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hDehdpbp->Draw();
  ANLGaussFitter gfit(hDehdpbp,kNsig);
  gfit.GetFunction()->Draw("same");
  hDehdpbp->SetFillColor(9);
  hDehdpbp->SetFillStyle(3002);
  hDehdpbp->GetXaxis()->SetTitle("#Delta E_{hd} [GeV]");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hDevis->Draw();
  ANLGaussFitter gfit(hDevis,kNsig);
  gfit.GetFunction()->Draw("same");
  hDevis->SetFillColor(50);
  hDevis->SetFillStyle(1000);
  hDevis->GetXaxis()->SetTitle("#Delta E_{vis} [GeV]");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hDecm->Draw();
  ANLGaussFitter gfit(hDecm,kNsig);
  gfit.GetFunction()->Draw("same");
  hDecm->SetFillColor(50);
  hDecm->SetFillStyle(1000);
  hDecm->GetXaxis()->SetTitle("E_{vis}-E_{cm} [GeV]");
#endif

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hEtkpbp->GetXaxis()->SetTitle("E_{tk} [GeV]");

  hEtkpbp->SetFillColor(42);
  hEtkpbp->SetFillStyle(3001);
  hEtkpbp->Draw();
  hEtkpbp->SetMaximum(1000);

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hEempbp->GetXaxis()->SetTitle("E_{EM} [GeV]");
  hEempbp->SetFillColor(42);
  hEempbp->SetFillColor(50);
  hEempbp->SetFillStyle(3001);
  hEempbp->Draw("same");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hEhdpbp->GetXaxis()->SetTitle("E_{HD} [GeV]");
  hEhdpbp->SetFillColor(42);
  hEhdpbp->SetFillColor(9);
  hEhdpbp->SetFillStyle(3002);
  hEhdpbp->Draw("same");

#if 1
  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hEahpbp->SetFillColor(42);
  hEahpbp->SetFillColor(38);
  hEahpbp->SetFillStyle(3001);
  hEahpbp->Draw("same");
#endif

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hEtotpbp->SetFillColor(42);
  hEtotpbp->SetFillColor(38);
  hEtotpbp->SetFillStyle(3001);
  hEtotpbp->Draw("same");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hEallpbp->SetFillColor(42);
  hEallpbp->SetFillColor(38);
  hEallpbp->SetFillStyle(3001);
  hEallpbp->Draw("same");

  c1.cd();
}
