#ifndef __S4VTXMCTRUTH__
#define __S4VTXMCTRUTH__
//*************************************************************************
//* ----------------
//* S4VTXMCTruth Class
//* ----------------
//* (Description)
//* (Requires)
//*	S4VMCTruth:
//* (Provides)
//*	S4VTXMCTruth		: steering class
//* (Update Record)
//*	2001/08/20  A.Yamaguchi	Original version.
//*************************************************************************

#include <fstream>
#include "S4VMCTruth.h"
#include "S4VTXTypeDef.h"
using namespace std;

class S4VTXMCTruth : public S4VMCTruth {

public:
   S4VTXMCTruth(const Char_t *fname = "hit.dat", 
                const Char_t *name  = "S4VTXMCTruth",
                const Char_t *title = "Get VTX ExactHit data");
	        
   virtual ~S4VTXMCTruth();

   Bool_t BeginRun(Int_t nrun);
   Bool_t Process (Int_t ev);

   void   DebugPrint(const Char_t *opt = "");
   
private:
   Char_t    *fInputFileName;            //!
   ifstream  *fInputStream;              //!

   ClassDef(S4VTXMCTruth, 1) // Read VTX ExactHit Data
};

#endif

