#ifndef __S4JETMAKER__
#define __S4JETMAKER__

//*************************************************************************
//* ---------------------
//* S4JetMaker Class
//* ---------------------
//* (Description)
//*	This set of classes makes Jets.
//* (Requires)
//*	JSFModules:
//* (Provides)
//*	S4JetMaker		: steering class
//* (Update Record)
//*	2004/10/05  S.Yamamoto	Original version.
//*************************************************************************

#include "JSFModule.h"

class S4JetMaker : public JSFModule {

public:
 S4JetMaker(const Char_t *name  = "S4JetMaker", 
            const Char_t *title = "Jet Maker");
 virtual ~S4JetMaker();

 virtual Bool_t Initialize();	     // job initialization
 virtual Bool_t BeginRun(Int_t run); // process Begin Run record
 virtual Bool_t Process(Int_t  ev);  // process event

 ClassDef(S4JetMaker, 1)      //  Jet maker
};

#endif

