#ifndef __S4JETSET__
#define __S4JETSET__

//*************************************************************************
//* ---------------------
//* S4JetSet Class
//* ---------------------
//* (Description)
//*	set of jets together with jet finder. 
//* (Requires)
//*	ANLJetFinder
//* (Provides)
//*	S4JetSet		: made object class
//* (Update Record)
//*	2004/10/16  S.Yamamoto	Original version.
//*************************************************************************
#include "TObjArray.h"
#include "ANLJetFinder.h"

class S4JetSet : public TObjArray {

public:
   S4JetSet(ANLJetFinder *jfp = 0, Bool_t ismine = kFALSE, Int_t njets = 10);
   virtual ~S4JetSet();

   virtual const ANLJetFinder &GetJetFinder() const;
   virtual void DebugPrint(const Char_t *opt = "");

private:
   ANLJetFinder *fJetFinderPtr; // pointer to jet finder
   Bool_t        fIsMine;

   ClassDef(S4JetSet, 1)        // JetSet class
};

#endif















