//*************************************************************************
//* --------------------
//* U4VHitMaker
//* --------------------
//* (Description)
//*	This set of classes makes pad hits.
//* (Requires)
//* (Provides) //* (Update Record)
//*	2004/08/07  A.Yamaguchi	Original version.
//*************************************************************************

#include <iostream>
#include "S4TPCHitMakerBuf.h"
#include "JSFSteer.h"

using namespace std;

ClassImp(S4TPCHitMaker)

//=====================================================================
//* constructor -------------------------------------------------------

S4TPCHitMaker::S4TPCHitMaker(const Char_t *name, const Char_t *title)
             : U4TPCHitMaker(name,title)
{
#ifdef __DEBUG__
   cerr << " constructor for S4TPCHitMaker is called..." << endl;
#endif
}
         
//=====================================================================
//* destructor --------------------------------------------------------

S4TPCHitMaker::~S4TPCHitMaker()
{
}

//=====================================================================
//* Initialize() ------------------------------------------------------

Bool_t S4TPCHitMaker::Initialize()
{
#ifdef __DEBUG__
   cerr << "S4TPCHitMaker::Initialize() is called..." << endl;
#endif
   fEventBuf = new S4TPCHitMakerBuf(this);
   return kTRUE;
}

//=====================================================================
//* Process -----------------------------------------------------------

Bool_t S4TPCHitMaker::Process(Int_t /*ev*/)
{
#ifdef __DEBUG__
   cerr << " S4TPCHitMaker::Process() is called..." << endl;
#endif

   S4TPCHitMakerBuf *hmbufp = static_cast<S4TPCHitMakerBuf *> (EventBuf());
   
   S4VMCTruth *mctp = (S4VMCTruth *)gJSF->FindModule("S4TPCMCTruth","quiet");
   if (!mctp) return kTRUE;
   S4VMCTruthBuf *mctbufp = (S4VMCTruthBuf *)mctp->EventBuf();
   hmbufp->SetInputDataBufPtr(mctbufp);	
   hmbufp->fInputBufPtr = mctbufp->GetExactHitsPtr();

   hmbufp->MakeHits();

   return kTRUE;
}
