//
// babyanl.C
//
// 

#include <iomanip.h>

TFile *foutp;

#if 1
extern TH2D *hRDX;
extern TH2D *hRDXmin;
#endif

int babyanl(Int_t run = 0)
{
  gROOT->Reset();
  
  gSystem->Load("libS4Utils.so");
  gSystem->Load("libS4MCTruth.so");
  gSystem->Load("libS4BabyMCTruth.so");
#if 1
  gSystem->Load("libU4HitMaker.so");
  gSystem->Load("libU4BabyHitMaker.so");
  gSystem->Load("libS4BabyHitMaker.so");
  gSystem->Load("libU4TrackMaker.so");  
  gSystem->Load("libU4BabyTrackMaker.so");  
  gSystem->Load("libS4BabyTrackMaker.so");  
  gSystem->Load("libS4BabyAnalysis.so");
#endif
  
  gRandom->SetSeed();
       
  JSFSteer *jsf = new JSFSteer();
    
  Char_t fname[13];
  foutp = new TFile("babyjsf.root","RECREATE"); //  Output file.
  TFile & fout = *foutp;
  
  if (!run) run = jsf->Env()->GetValue("JSFSteer.RunNo",1615);  
  cerr << " RunNo = " << run << endl;

  jsf->SetOutput(fout);


  Int_t nevent=jsf->Env()->GetValue("JSFSteer.Nevent",98);  
  Int_t minevt=1;
  Int_t maxevt=minevt+nevent;

  S4BabyMCTruth     *mctruth     = new S4BabyMCTruth("baby.dat");  
#if 1
  S4BabyHitMaker    *hitmaker    = new S4BabyHitMaker();
  S4BabyTrackMaker  *trackmaker  = new S4BabyTrackMaker();
  S4BabyAnalysis    *analysis    = new S4BabyAnalysis();
#endif

//==================================
// set parameters
//----------------------------------

  // Remove Dalta-Ray hits ....    
     mctruth->RemoveDeltaRayHits();
#if 1 
  // Saturation effect ....    
     analysis->SaturationOn();
     analysis->SetMode(0);
     analysis->SetNsigCut(5.);
     analysis->SetChi2Cut(64.);
 
  // Two-track Separation ....
     Int_t twotrack = jsf->Env()->GetValue("JSFSteer.TwoTrackSeparation",1.0);  
     Double_t twotracksep = twotrack / 10000.; 
     S4BabyHitWire::SetTwoHitSeparation(twotracksep);
//     cerr << " twotracksep = " << twotracksep << endl;  
   S4BabyHitWire::SetTwoHitSeparationZ(0.3);
 
  // Set IP constraint ....
//     S4BabyTrack::SetIPConstraint(kTRUE);
     
  // Simulation Mode (Baby or TPC) ....
     S4BabyHitWire::TPCMode(kFALSE);
#endif          
//----------------------------------
//==================================
 
   jsf->Initialize();
  
    
  jsf->BeginRun(run);      // Set run number

  for(Int_t ev=minevt;ev<=maxevt;ev++){
    
    cerr << " ---- Event " << ev << " ----" << endl;
    Int_t ib;
    if( ! jsf->Process(ev) ) {

cerr << "jsf->Process is faild." << endl;

      jsf->FillTree();
      jsf->Clear();
      break;
    }
    jsf->FillTree();
    jsf->Clear();
  }
  jsf->Terminate();
  fout.Write();

}



