#ifndef __U4BABYTRACKMAKERBUF__
#define __U4BABYTRACKMAKERBUF__

//*************************************************************************
//* ---------------------
//* U4BabyTrackMakerBuf Class
//* ---------------------
//* (Description)
//*
//* (Requires)
//*	JSFEventBuf
//* (Provides)
//*	U4BabyTrackMakerBuf		: buffering class
//* (Update Record)
//*	1999/12/04  R.Kuboshima	    Original version.
//*************************************************************************

#include "JSFSteer.h"
#include "U4CDCTrackMakerBuf.h"
#include "U4BabyTrackMaker.h"
#include "U4CDCHitCell.h"
#include "U4CDCHitMakerBuf.h"

class U4BabyTrack;

class U4BabyTrackMakerBuf : public U4CDCTrackMakerBuf {
friend class U4BabyTrackMaker;

public:

  U4BabyTrackMakerBuf(const char *name="U4BabyTrackMakerBuf",
                      const char *title="Baby Track data",
		      U4BabyTrackMaker *module=0, Int_t bufsize = 2000);
  U4BabyTrackMakerBuf(U4BabyTrackMaker *module,
                      const char *name="U4BabyTrackMakerBuf",
                      const char *title="Baby Track data",
                      Int_t bufsize = 2000);
		    
  virtual ~U4BabyTrackMakerBuf();
  virtual void 	DebugPrint(const Char_t *opt = "Brief");
#if 0  
  
  inline virtual void   SetChi2Cut(Double_t x)     { xChi2	= x; }
  inline virtual void   SetNsigCut(Double_t x)     { xNsigmas   = x; }
  inline virtual void   SetDXpivotCut(Double_t x)  { xDXpivot   = x; }
  inline virtual void   SetKCNsigCut(Double_t x)   { xKCNsigmas = x; }
  inline virtual void   SetSlopeCut(Double_t x)    { xSlope     = x; }
  inline virtual void   SetInterceptMin(Double_t x){ fBmin      = x; }
  inline virtual void   SetInterceptMax(Double_t x){ fBmax      = x; }
  inline virtual void   SetInterceptNbins(Int_t  n){ fNbins     = n; }
                 void   SetHitData(U4CDCHitMakerBuf *htbuf);
#endif
		 
  Bool_t		IsInitialized() const;  // inquires if input data set
  Int_t			GetNtracks();		// returns No. tracks
  TObjArray	       *GetTracks();		// returns array of tracks
  TObjArray	       *GetJunkVHit();		// returns array of JunkVHit
  Int_t                 Ntracks;
#if 0
  inline virtual U4CDCHitMakerBuf *GetHitMakerBufPtr()
  {
      U4CDCHitMaker *hm = (U4CDCHitMaker*)gJSF->FindModule("U4CDCHitMaker");
      return (U4CDCHitMakerBuf *)hm->EventBuf();
  }
#endif
protected:  
  virtual void	MakeTracks() ;	// Make Baby Tracks
  void MakeVectorHits(U4CDCHitCell *celp, TObjArray *truevhittmpp);
  
protected:  
  U4CDCHitMakerBuf   *fHitData;
  //TObjArray           fTracks;

  ClassDef(U4BabyTrackMakerBuf, 1) // Cluster data buffer
};

#endif













