#ifndef __U4CDCCLUSTERMAKER__
#define __U4CDCCLUSTERMAKER__

//***********************************************************************
//* -------------------------
//* Cluster Maker
//* -------------------------
//***********************************************************************

#include <iostream>
#include <iomanip>
#include "TClass.h"
#include "TObjArray.h"

#include "JSFSteer.h"
#include "JSFModule.h"
#include "U4CDCRawData.h"
#include "U4CDCFADCCalibration.h"

class U4CDCClusterMaker : public JSFModule {
public:
  U4CDCClusterMaker(U4CDCFADCCalibration *calib = 0,
                  const Char_t *name="U4CDCClusterMaker",
                  const Char_t *title="U4CDC Cluster Maker");
  virtual ~U4CDCClusterMaker();

  void          SetCalibrationData(U4CDCFADCCalibration *calib);
  void          UseVarPed();
  void          UseConstPed();

  Bool_t        Initialize();           // job initialization
  Bool_t        BeginRun(Int_t run);    // process Begin Run record
  Bool_t        Process(Int_t  ev);     // process event
  
private:
  Bool_t              fUseVarPed;       // (1,0) = (var ped, const ped)
  Bool_t              fToDeleteCalib;   // delete Calib in dtor or not
  U4CDCFADCCalibration *fCalib;           // pointer to calibration data object
  
  ClassDef(U4CDCClusterMaker, 1)  // U4CDC cluster maker
};

#endif
