//*************************************************************************
//* --------------------
//* U4HYBTrackMakerBuf
//* --------------------
//* (Description)
//*	This set of classes to make hybrid tracks.
//* (Requires)
//* (Provides)
//* (Update Record)
//*	2004/09/07  K.Fujii	Original version.
//*************************************************************************

#include <iostream>
#include <iomanip>
#include "U4HYBTrackMakerBuf.h"
#include "U4HYBTrack.h"


ClassImp(U4HYBTrackMakerBuf)

//=====================================================================
//* constructor -------------------------------------------------------
U4HYBTrackMakerBuf::U4HYBTrackMakerBuf(const Char_t          *name,
                                       const Char_t          *title, 
			                     U4HYBTrackMaker *module,
                                             Int_t            bufsize) 
		   : U4VTrackMakerBuf(name, title, module, bufsize)
{
}

U4HYBTrackMakerBuf::U4HYBTrackMakerBuf(      U4HYBTrackMaker *module,
	                               const Char_t          *name, 
			               const Char_t          *title,
                                             Int_t            bufsize)
		   : U4VTrackMakerBuf(module, name, title, bufsize)
{
}

//=====================================================================
//* destructor --------------------------------------------------------

U4HYBTrackMakerBuf::~U4HYBTrackMakerBuf()
{  
}

//=====================================================================
//* MakeTracks --------------------------------------------------------

void U4HYBTrackMakerBuf::MakeTracks()
{
   TIter next(static_cast<U4VTrackMakerBuf *>(GetInputDataBufPtr())->GetOutputBufPtr());
   U4VTrack *mtrkp = 0;   // main track pointer
   while ((mtrkp = dynamic_cast<U4VTrack *>(next()))) {
      U4HYBTrack *htrkp = CreateHYBTrack();
      htrkp->Add(mtrkp);
      TIter nextsubtrkr(GetInputSubTrackerPtr());
      U4VTrackMakerBuf *subtrkrp = 0;
      while ((subtrkrp = dynamic_cast<U4VTrackMakerBuf *>(nextsubtrkr()))) {
         U4VTrack *tmptrkp = subtrkrp->MakeOneTrack(htrkp);
         if (tmptrkp) htrkp->Add(tmptrkp);
      }
      GetOutputBufPtr()->Add(htrkp);
   }
}

//=====================================================================
//* DebugPrint --------------------------------------------------------

void U4HYBTrackMakerBuf::DebugPrint(const Char_t *opt)

{
}
