#ifndef __U4ITTRACKHIT__
#define __U4ITTRACKHIT__
//*************************************************************************
//* ---------------------
//* U4ITTrackHit Class
//* ---------------------
//* (Description)
//*	Class for a single track hit.
//* (Requires)
//*	TObjArray
//* (Provides)
//*	U4ITTrackHit		: 
//* (Update Record)
//*	2004/08/26  A.Yamaguchi
//*************************************************************************

#include "U4VTrackHit.h"
#include "U4ITHit.h"


class U4ITTrackHit : public U4VTrackHit {
friend class U4ITTrack;
public:
  U4ITTrackHit();
  U4ITTrackHit(U4ITHit *ht);
  U4ITTrackHit(const U4ITTrackHit &hit);
  virtual ~U4ITTrackHit();

  static  void   SetSortBy (Char_t *opt);
  virtual Int_t  Compare   (const TObject *obj) const;
       
  inline virtual U4ITHit *GetHitPtr()
  {
     return  dynamic_cast<U4ITHit *>(U4VTrackHit::GetHitPtr());
  }


  ClassDef(U4ITTrackHit, 1)       // IT Hit
};


#endif
