#ifndef __U4IPMEASLAYER__
#define __U4IPMEASLAYER__
//*************************************************************************
//* ===================
//*  U4IPMeasLayer Class
//* ===================
//*
//* (Description)
//*   Sample measurement layer class used by U4IPKalHit.
//* (Requires)
//* (Provides)
//*     class U4IPMeasLayer
//* (Update Recored)
//*   2003/09/30  Y.Nakashima       Original version.
//*
//*************************************************************************

#include "TVector3.h"

#include "TKalMatrix.h"
#include "TPlane.h"
#include "U4VMeasLayer.h"

class TVTrackHit;

class U4IPMeasLayer : public U4VMeasLayer, public TPlane {
public:

   // Ctors and Dtor

   U4IPMeasLayer(TMaterial &matIn,
                 TMaterial &matOut,
                 TVector3  &xc,
                 TVector3  &n,
                 Bool_t     isactive = kTRUE);
   virtual ~U4IPMeasLayer();

   // Parrent's pure virtuals that must be implemented

   virtual TKalMatrix XvToMv    (const TVTrackHit &ht,
                                 const TVector3   &xv) const;
   virtual TKalMatrix XvToMv    (const TVector3   &xv) const;
   virtual TVector3   HitToXv   (const TVTrackHit &ht) const;
   virtual void       CalcDhDa  (const TVTrackHit &ht,
                                 const TVector3   &xv,
                                 const TKalMatrix &dxphiada,
                                       TKalMatrix &H)      const;

private:
   ClassDef(U4IPMeasLayer,1) 	// Sample measurement layer class
};

#endif
