//*************************************************************************
//* --------------------
//* U4VTrackMakerBuf
//* --------------------
//* (Description)
//*	This set of classes makes pad Tracks.
//* (Requires)
//* (Provides)
//* (Update Record)
//*	2001/08/22  K.Hoshina	Original version.
//*************************************************************************

#include "U4VTrackMakerBuf.h"
#include "U4VTrack.h"
#include <iostream>


ClassImp(U4VTrackMakerBuf)

//=====================================================================
//* constructor -------------------------------------------------------

U4VTrackMakerBuf::U4VTrackMakerBuf(const char *name, const char *title, 
			           U4VTrackMaker *module, Int_t bufsize) 
		    :JSFEventBuf(name, title, (JSFModule*)module),
		     fDone(kFALSE), fOutputBuf(bufsize),fInputDataBufPtr(0)
{
	fOutputBuf.SetOwner();
}

U4VTrackMakerBuf::U4VTrackMakerBuf(U4VTrackMaker *module, const char *name, 
			       const char *title, Int_t bufsize)
		    :JSFEventBuf(name, title, (JSFModule*)module),
		     fDone(kFALSE), fOutputBuf(bufsize),fInputDataBufPtr(0)
{
	fOutputBuf.SetOwner();
}

//=====================================================================
//* destructor --------------------------------------------------------

U4VTrackMakerBuf::~U4VTrackMakerBuf()
{
	fOutputBuf.Delete();
}

//=====================================================================
//* GetOutputBufPtr ------------------------------------------------------

TObjArray* U4VTrackMakerBuf::GetOutputBufPtr()
{
	return &fOutputBuf;
}

//=====================================================================
//* GetEntries --------------------------------------------------------

Int_t U4VTrackMakerBuf::GetEntries()
{
	return fOutputBuf.GetEntries();
}

//=====================================================================
//* SetInputDataBuf ---------------------------------------------------

void U4VTrackMakerBuf::SetInputDataBufPtr(JSFEventBuf *buf)
{
	fDone            = kFALSE;
	fInputDataBufPtr = buf;
	if (fOutputBuf.GetEntries() > 0) fOutputBuf.Clear();
}








