//*************************************************************************
//* ---------------------
//* U4TPCHit Class
//* ---------------------
//* (Description)
//*	Class for a single TPC hit.
//* (Requires)
//*	TObject
//* (Provides)
//*	U4TPCHit		: TObject containing single hit data
//* (Update Record)
//*	2004/08/07  A.Yamaguchi	Original version.
//*************************************************************************

#include <iostream>
#include <iomanip>
#include "U4TPCHit.h"

ClassImp(U4TPCHit)
	

U4TPCHit::U4TPCHit(Int_t    padrowno,
                         Double_t padrowr,
                         Int_t    side,
                         Double_t phi)
        : fDone(kFALSE), 
  	  fRPhi(0.),
          fDRPhi(0.),
          fZdrift(0.),
          fDZdrift(0.),
          fPadRowNumber(padrowno), 
          fPadRowRadius(padrowr ),
          fSide(side),
          fVdrift(0.), 
          fPhi(phi)
{
}

U4TPCHit::~U4TPCHit() 
{	
}

Bool_t U4TPCHit::IsSortable() const { return kTRUE; }

Int_t U4TPCHit::Compare(const TObject *obj) const
{
    return 0;
}

void U4TPCHit::DebugPrint(const Char_t *opt)
{
}

void U4TPCHit::Update()
{
   if (fDone) return;
   fDone = kTRUE;
   CalculatePosition();
}

void U4TPCHit::CalculatePosition()
{
}

