//*************************************************************************
//* ---------------------
//* U4VTXTrackHit Class
//* ---------------------
//* (Description)
//*	Class for a single Baby hit.
//* (Requires)
//*	TObject
//* (Provides)
//*	U4VTXTrackHit		: 
//* (Update Record)
//*	2004/08/24  A.Yamaguchi
//*************************************************************************

#include "U4VTXTrackHit.h"

ClassImp(U4VTXTrackHit)

//=====================================================================
//* constructor -------------------------------------------------------

U4VTXTrackHit::U4VTXTrackHit()
{
}

U4VTXTrackHit::U4VTXTrackHit(U4VTXHit *htp)
            : U4VTrackHit(htp)
{
}
	
U4VTXTrackHit::U4VTXTrackHit(const U4VTXTrackHit &hit)
            : U4VTrackHit(hit) 
{
}

//=====================================================================
//* destructor --------------------------------------------------------

U4VTXTrackHit::~U4VTXTrackHit()
{
}

//=====================================================================
//* SetSortBy --------------------------------------------------------
                                                                                
void U4VTXTrackHit::SetSortBy(Char_t *opt )
{
   switch (opt[2]) {
         case 'y':       // sort by "LayerID"
         default:
            U4VTrackHit::SetSortBy(0);
            break;
   }
}
                                                                                
//=====================================================================
//* Compare -----------------------------------------------------------
Int_t U4VTXTrackHit::Compare(const TObject *obj) const
{
   switch (GetSortBy()) {
      case 0:
      default: {
         Int_t layerID   = const_cast<U4VTXTrackHit *>(this)
                                        ->GetHitPtr()->GetLayerID();
         Int_t layerIDo  = ((U4VTXTrackHit *)obj)
                                        ->GetHitPtr()->GetLayerID();
         return (layerID < layerIDo ? -1 : (layerID > layerIDo ? 1 : 0));
      }
   }
}
